module Quandl
  module Utility
    class Tasks
      class << self
        attr_accessor :configuration
      end

      def self.configuration
        @configuration ||= TaskConfig.new
      end

      def self.configure
        yield(configuration)
        load File.join(Quandl::Utility.root_path, 'tasks/utility.rake')
        true
      end

      class TaskConfig < Quandl::Utility::Configuration
        define_attributes :name, :changelog_path, :changelog_matching, :version_path, :tag_prefix

        def version_with_prefix
          "#{tag_prefix}#{version}"
        end

        def tag_prefix
          read_attribute(:tag_prefix)
        end

        def version
          @version ||= File.exist?(version_path) ? File.read(version_path) : '0.0.0'
        end
      end
    end
  end
end
